﻿' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください
Option Strict On

Imports Windows.Devices.Geolocation
Imports Bing.Maps
Imports Windows.UI
Imports Windows.UI.Core
Imports System.Net.Http
Imports Windows.UI.Popups

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public NotInheritable Class MainPage
    Inherits Page

    Dim myGeolocator As Geolocator
    'Dim myLatitude As String
    'Dim myLongitude As String
    Dim myCoreDispacher As CoreDispatcher
    Const AppID As String = "YahooのアプリケーションID"
    Const GoogleAppID As String = "GoogleのアプリケーションID"
    Dim flag As Boolean = False
    Dim myCoodinatePosition As String = String.Empty
    Dim myAddressCoodinatePosition As String = String.Empty
    Dim myUri As String = String.Empty
    Dim myAddressLatitude As String
    Dim myAddressLongitude As String
    Dim myAddressUri As String
    Protected Overrides Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        DataShow()
    End Sub

    Private Sub DataShow()
        If myGeolocator Is Nothing = True Then
            myGeolocator = New Geolocator
            myGeolocator.DesiredAccuracy = PositionAccuracy.Default
            myCoreDispacher = Window.Current.CoreWindow.Dispatcher
        End If
        AddHandler myGeolocator.PositionChanged, AddressOf myGeolocator_PositionChanged
        AddHandler myGeolocator.StatusChanged, AddressOf myGeolocator_StatusChanged
    End Sub

    Private Async Sub myGeolocator_PositionChanged(sender As Geolocator, args As PositionChangedEventArgs)

        Dim myLatitude As String = String.Empty
        Dim myLongitude As String = String.Empty
        Dim no As Integer = 0

        'Dim myCoordinate As Geocoordinate = args.Position.Coordinate
        'myLatitude = CStr(myCoordinate.Latitude)
        'myLongitude = CStr(myCoordinate.Longitude)
        Await myCoreDispacher.RunAsync(CoreDispatcherPriority.Normal, Async Sub()
                                                                          Dim pos As Geoposition = args.Position
                                                                          myMap.Children.Clear()

                                                                          Dim myPin As New Pushpin
                                                                          Dim myLocation As Location
                                                                          myPin.Background = New SolidColorBrush(Colors.Navy)
                                                                          If flag = True Then
                                                                              myLocation = New Location(CDbl(myAddressLatitude), CDbl(myAddressLongitude))
                                                                          Else
                                                                              myLocation = New Location(CDbl(pos.Coordinate.Latitude), CDbl(pos.Coordinate.Longitude))
                                                                          End If

                                                                          MapLayer.SetPosition(myPin, myLocation)
                                                                          myMap.Children.Add(myPin)
                                                                          myMap.SetView(myLocation, 16)


                                                                          If flag = True Then
                                                                              myAddressUri = String.Format("http://reverse.search.olp.yahooapis.jp/OpenLocalPlatform/V1/reverseGeoCoder?lat={0}&lon={1}&appid={2}", myAddressLatitude, myAddressLongitude, AppID)
                                                                          Else
                                                                              myAddressUri = String.Format("http://reverse.search.olp.yahooapis.jp/OpenLocalPlatform/V1/reverseGeoCoder?lat={0}&lon={1}&appid={2}", pos.Coordinate.Latitude, pos.Coordinate.Longitude, AppID)
                                                                          End If

                                                                          Dim myAddressHttpClient As New HttpClient
                                                                          Dim myCurrentAddress As String = String.Empty
                                                                          Dim xmldoc As XElement
                                                                          Try
                                                                              myCurrentAddress = Await myAddressHttpClient.GetStringAsync(myAddressUri)
                                                                              myCurrentAddress = myCurrentAddress.Replace("<YDF firstResultPosition=" & ChrW(34) & "1" & ChrW(34) & " totalResultsAvailable=" & ChrW(34) & "1" & ChrW(34) & " totalResultsReturned=" & ChrW(34) & "1" & ChrW(34) & " xmlns=" & ChrW(34) & "http://olp.yahooapis.jp/ydf/1.0" & ChrW(34) & ">", "<YDF>")
                                                                              xmldoc = XElement.Parse(myCurrentAddress)


                                                                              Dim myAddress = xmldoc.Descendants("Address").Value

                                                                              Dim myAddressStackPanel As New StackPanel
                                                                              myAddressStackPanel.Margin = New Thickness(5)
                                                                              myAddressStackPanel.Background = New SolidColorBrush(Colors.Navy)
                                                                              myAddressStackPanel.Visibility = Xaml.Visibility.Collapsed
                                                                              Dim myAddressTextBlock As New TextBlock
                                                                              myAddressTextBlock.Foreground = New SolidColorBrush(Colors.Red)
                                                                              myAddressTextBlock.FontSize = 24
                                                                              myAddressTextBlock.Padding = New Thickness(5)
                                                                              If flag = False Then
                                                                                  myAddressTextBlock.Text = myAddress & " 辺り"
                                                                              Else
                                                                                  myAddressTextBlock.Text = WatermarkTextBox.Text & " 辺り"
                                                                              End If

                                                                              myAddressStackPanel.Children.Add(myAddressTextBlock)
                                                                              myAddressStackPanel.SetValue(Canvas.ZIndexProperty, 20)



                                                                              If flag = True Then
                                                                                  MapLayer.SetPosition(myAddressStackPanel, New Location(CDbl(myAddressLatitude), CDbl(myAddressLongitude)))
                                                                              Else
                                                                                  MapLayer.SetPosition(myAddressStackPanel, New Location(CDbl(pos.Coordinate.Latitude), CDbl(pos.Coordinate.Longitude)))
                                                                              End If

                                                                              myMap.Children.Add(myAddressStackPanel)

                                                                              AddHandler myPin.Tapped, Sub()
                                                                                                           myAddressStackPanel.Visibility = Xaml.Visibility.Visible
                                                                                                       End Sub

                                                                              AddHandler myAddressStackPanel.Tapped, Sub()
                                                                                                                         myAddressStackPanel.Visibility = Xaml.Visibility.Collapsed
                                                                                                                     End Sub

                                                                              'Dim message As New MessageDialog(pos.Coordinate.Latitude.ToString & "--------" & pos.Coordinate.Longitude.ToString)
                                                                              'Await message.ShowAsync
                                                                              '現在地から600M以内のお店を表示



                                                                              If flag = True Then
                                                                                  myUri = String.Format("https://maps.googleapis.com/maps/api/place/nearbysearch/xml?location={0}&radius=1000&types=hospital&sensor=true&language=ja&key={1}", myAddressCoodinatePosition, GoogleAppID)
                                                                                  TitleTextBlock.Text = WatermarkTextBox.Text & " 辺りの1Km範囲内の病院を表示"
                                                                              Else
                                                                                  myCoodinatePosition = pos.Coordinate.Latitude & "," & pos.Coordinate.Longitude
                                                                                  myUri = String.Format("https://maps.googleapis.com/maps/api/place/nearbysearch/xml?location={0}&radius=1000&types=hospital&sensor=true&language=ja&key={1}", myCoodinatePosition, GoogleAppID)
                                                                                  TitleTextBlock.Text = myAddress & " 辺りの1Km範囲内の病院を表示"
                                                                              End If

                                                                              Dim myHttpClient As New HttpClient
                                                                              Dim resultHospital = Await myHttpClient.GetStringAsync(myUri)

                                                                              'resultConbini = resultConbini.Replace("<YDF xmlns=" & ChrW(34) & "http://olp.yahooapis.jp/ydf/1.0" & ChrW(34), "<YDF ")
                                                                              'Dim message As New MessageDialog(resultHospital)
                                                                              'Await message.ShowAsync

                                                                              Dim httpDoc As XElement = XElement.Parse(resultHospital)

                                                                              For Each result In From c In httpDoc.Descendants("result") Select c
                                                                                  no += 1
                                                                                  Dim hospitalPin As New Pushpin
                                                                                  hospitalPin.Background = New SolidColorBrush(Colors.Crimson)
                                                                                  hospitalPin.Text = no.ToString
                                                                                  myLongitude = result.Element("geometry").Element("location").Element("lng").Value
                                                                                  myLatitude = result.Element("geometry").Element("location").Element("lat").Value

                                                                                  Dim hospitalLocation = New Location(CDbl(myLatitude), CDbl(myLongitude))
                                                                                  MapLayer.SetPosition(hospitalPin, hospitalLocation)
                                                                                  myMap.Children.Add(hospitalPin)

                                                                                  Dim myStackPanel As New StackPanel
                                                                                  myStackPanel.Margin = New Thickness(5)
                                                                                  myStackPanel.Background = New SolidColorBrush(Colors.Navy)
                                                                                  myStackPanel.Visibility = Xaml.Visibility.Collapsed

                                                                                  Dim myNameTextBlock As New TextBlock
                                                                                  myNameTextBlock.Foreground = New SolidColorBrush(Colors.Red)
                                                                                  myNameTextBlock.Width = 400
                                                                                  myNameTextBlock.TextWrapping = TextWrapping.Wrap
                                                                                  myNameTextBlock.FontSize = 24
                                                                                  myNameTextBlock.Padding = New Thickness(5)
                                                                                  myNameTextBlock.Text = "【病院名】=" & result.Element("name").Value

                                                                                  Dim addressTextBlock As New TextBlock
                                                                                  addressTextBlock.Foreground = New SolidColorBrush(Colors.Beige)
                                                                                  addressTextBlock.Width = 400
                                                                                  addressTextBlock.TextWrapping = TextWrapping.Wrap
                                                                                  addressTextBlock.FontSize = 20
                                                                                  addressTextBlock.Padding = New Thickness(5)
                                                                                  addressTextBlock.Text = "【住所】=" & result.Element("vicinity").Value

                                                                                  Dim myButton As New Button
                                                                                  With myButton
                                                                                      .Content = "Webで表示"
                                                                                      .Tag = no.ToString
                                                                                  End With

                                                                                  myStackPanel.SetValue(Canvas.ZIndexProperty, no)
                                                                                  myStackPanel.Children.Add(myNameTextBlock)
                                                                                  myStackPanel.Children.Add(addressTextBlock)
                                                                                  myStackPanel.Children.Add(myButton)

                                                                                  MapLayer.SetPosition(myStackPanel, New Location(CDbl(myLatitude), CDbl(myLongitude)))
                                                                                  myMap.Children.Add(myStackPanel)

                                                                                  AddHandler hospitalPin.Tapped, Sub()
                                                                                                                     myStackPanel.Visibility = Xaml.Visibility.Visible
                                                                                                                 End Sub

                                                                                  AddHandler myStackPanel.Tapped, Sub()
                                                                                                                      myStackPanel.Visibility = Xaml.Visibility.Collapsed
                                                                                                                  End Sub

                                                                                  AddHandler myButton.Click, Async Sub(mySender As Object, myArgs As RoutedEventArgs)
                                                                                                                 'AppBar1.Visibility = Xaml.Visibility.Collapsed
                                                                                                                 'myMap.Visibility = Xaml.Visibility.Collapsed
                                                                                                                 'myFrame.Visibility = Xaml.Visibility.Visible
                                                                                                                 Dim index = DirectCast(mySender, Button).Tag
                                                                                                                 Dim myIndex = CInt(index) - 1
                                                                                                                 Dim mySendAddress = "http://www.bing.com/search?q=" & Uri.EscapeDataString(httpDoc.Descendants("vicinity")(myIndex).Value & " " & httpDoc.Descendants("name")(myIndex).Value)
                                                                                                                 'myFrame.Navigate(GetType(WebBrowserPage), mySendAddress)
                                                                                                                 Await Windows.System.Launcher.LaunchUriAsync(New Uri(mySendAddress))
                                                                                                             End Sub


                                                                              Next
                                                                          Catch
                                                                              ErrorShow()
                                                                          End Try
                                                                      End Sub)



    End Sub

    Private Async Sub ErrorShow()
        Dim message As New MessageDialog("住所が不正です。現在位置を表示します。")
        Await message.ShowAsync
        resetButton_Click(Nothing, Nothing)
    End Sub

    Private Async Sub myGeolocator_StatusChanged(sender As Geolocator, args As StatusChangedEventArgs)
        Dim positionStatus = args.Status
        Select Case positionStatus
            Case Windows.Devices.Geolocation.PositionStatus.Disabled
                Await myCoreDispacher.RunAsync(CoreDispatcherPriority.Normal, Sub()
                                                                                  TitleTextBlock.Text = "位置情報を取得できません。GPSおよび位置情報取得可能なPCでお試しください。"
                                                                                  Exit Sub
                                                                              End Sub)

        End Select
    End Sub


    Private Sub okButton_Click(sender As Object, e As RoutedEventArgs) Handles okButton.Click

        If WatermarkTextBox.Text <> String.Empty Then
            flag = True
            RemoveHandler myGeolocator.PositionChanged, AddressOf myGeolocator_PositionChanged
            RemoveHandler myGeolocator.StatusChanged, AddressOf myGeolocator_StatusChanged
            Dim addressUri = String.Format("http://www.geocoding.jp/api/?v=1.1&q={0}", WatermarkTextBox.Text)
            Dim myHttpClient As New HttpClient
            Dim myResponse = myHttpClient.GetStringAsync(New Uri(addressUri, UriKind.Absolute))
            Dim myContent = myResponse.Result
            Dim xmldoc As XElement = XElement.Parse(myContent)
            myAddressLatitude = xmldoc.Descendants("coordinate").Elements("lat").Value
            myAddressLongitude = xmldoc.Descendants("coordinate").Elements("lng").Value
            myAddressCoodinatePosition = myAddressLatitude & "," & myAddressLongitude
            myMap.Children.Clear()
            DataShow()
        Else
            flag = False
            Exit Sub
        End If
    End Sub

    Private Sub resetButton_Click(sender As Object, e As RoutedEventArgs) Handles resetButton.Click
        flag = False
        RemoveHandler myGeolocator.PositionChanged, AddressOf myGeolocator_PositionChanged
        RemoveHandler myGeolocator.StatusChanged, AddressOf myGeolocator_StatusChanged
        myMap.Children.Clear()
        DataShow()
    End Sub
End Class


